namespace BP
{
	namespace Controller
	{
		class Flare : ScriptObject
		{
			kActor@ self;
			kParticle@ flareParticle;
			kParticle@ damageParticle;
			kParticle@ damageSpriteParticle;
			//------------------------------------------------------------------------------------------------------------------------
			Flare(kActor@ actor)
			{
				@self = actor;
			}
			//------------------------------------------------------------------------------------------------------------------------
			void Dispose()
			{
				if (flareParticle !is null && !flareParticle.IsStale())
				{
					flareParticle.Remove();
				}
				if (!self.IsStale())
				{
					self.Remove();
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnTick(void)
			{
				if (self.GetTarget() is null)
				{
					Dispose();
					return;
				}
				
				@flareParticle = self.GetTarget().CastToParticle();
				
				if (flareParticle.IsStale())
				{
					Dispose();
					return;
				}
				
				if (flareParticle.IsSticking())
				{
					if (damageParticle is null)
					{
						kActor @flareOwner = @self;
						if (BP::mapScript.gameModeMP == MP_GAMEMODE_RAPTORFEST)
						{
							@flareOwner = flareParticle.Owner();
						}
						@damageParticle = BP::Spawn::Particle("particles/BP/Flare_Damage.particle", flareOwner, flareParticle.Origin());
						DebugAssert(damageParticle !is null, "[BP::Controller::Flare::OnTick] damageParticle is null");
					}
					if (damageSpriteParticle is null)
					{
						@damageSpriteParticle = BP::Spawn::Particle("particles/BP/Flare_Sprite.particle", self, flareParticle.Origin());
						DebugAssert(damageSpriteParticle !is null, "[BP::Controller::Flare::OnTick] damageSpriteParticle is null");
					}
				}

				self.Origin() = flareParticle.Origin(); //for the looping sound to play where the flare is
				
				if (damageParticle !is null)
				{
					damageParticle.Origin() = flareParticle.Origin();
					if (damageSpriteParticle !is null)
					{
						damageSpriteParticle.Origin() = flareParticle.Origin();
					}
					
					if (damageParticle.IsStale())
					{
						Dispose();
						return;
					}
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
