namespace BP
{
	class WorldChar : BP::ScriptActor
	{
		float offset;
		kVec3 origin;
		kVec3 originOffset;
		kActor@ srcActor;
		kActor@ target;
		//------------------------------------------------------------------------------------------------------------------------
		WorldChar(kActor@ actor)
		{
			super(actor);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnSerialize(kDict dict) override
		{
			SERIALIZE_FLOAT(offset);
			SERIALIZE_VECTOR(origin);
			SERIALIZE_VECTOR(originOffset);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnDeserialize(kDict& in dict) override
		{
			DESERIALIZE_FLOAT(offset);
			DESERIALIZE_VECTOR(origin);
			DESERIALIZE_VECTOR(originOffset);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Setup(kActor@ srcActor, kActor@ target, const int charValue, const kVec3& in origin, const kVec3& in originOffset, const float offset)
		{
			@this.srcActor = srcActor;
			@this.target = target;
			this.origin = origin;
			this.originOffset = originOffset;
			this.offset = offset;
			
			this.origin += originOffset;
			kParticle @particle = BP::Spawn::Particle(BP_Particle_CharStart + charValue, @self);
			if (particle is null)
			{
				//this message gets spammed in mp alot of the time
				//DebugError("[BP::WorldChar::UserEvent] Spawning particle " + charValue + " returned null");
				self.Remove();
			}
			else
			{
				particle.Origin() = this.origin;
			}
			self.SetTarget(@particle);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnTick() override
		{
			if (self.GetTarget() is null)
			{
				self.Remove();
				return;
			}

			kParticle @particle = self.GetTarget().CastToParticle();
			
			if (particle.IsStale())
			{
				self.Remove();
				return;
			}
			
			if (target !is null)
			{
				origin = target.Origin() + originOffset;
			}
			
			if (srcActor !is null)
			{
				kVec3 localDir = kVec3(1, 0, 0) * (kVec3(origin.x, origin.y, srcActor.Origin().z) - srcActor.Origin()).ToQuat();
				particle.Origin() = origin + localDir * offset;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
}
