//TID
//1012 HUB2 Map Actor
//64000 Warp 1 middle
//64001 Warp 2 top
//1000 2 Gold Horse Statues
//1001 Sector to trigger 1000
//1002 Hatch below power plant
//1003 Top Door big set
//1004 Skull Ground Switch
//1005 Corner Tower
//1006 Counsel Door
//1007 Underwater tower Door
//1008 Power Station Door
//1009 Power Gen Switch Right
//1010 Power Gen Switch Left
//1011 Underwater laser door
//1013 Ion Capacitor Switch Right
//1014 Ion Capacitor Switch Left

//warp args: arg 3 = Warp TID, arg 7 = mapID
namespace BP
{
	namespace Maps
	{
		class HUB2 : ScriptMap
		{
			int generators;
			int ionCapacitors;
			//------------------------------------------------------------------------------------------------------------------------
			HUB2(kActor@ actor)
			{
				super(actor);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnStart() override
			{
				ScriptMap::BP_OnStart();
				
				kActor @enemy = BP::Spawn::Actor(BP_Actor_AI_Endtrail, kVec3(60.0f, -1773.0f, 2151.0f));
				enemy.Flags() |= AF_NODAMAGE;
				BP::Actor::SetAIPath(@enemy, array<int> = { 1000, 1001 }, true);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnSerialize(kDict dict) override
			{
				ScriptMap::BP_OnSerialize(dict);
				SERIALIZE_INT(generators);
				SERIALIZE_INT(ionCapacitors);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnDeserialize(kDict& in dict) override
			{
				ScriptMap::BP_OnDeserialize(dict);
				DESERIALIZE_INT(generators);
				DESERIALIZE_INT(ionCapacitors);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTrigger(kActor@ pInstigator, const int msg) override
			{
				ScriptMap::BP_OnTrigger(pInstigator, msg);
				
				switch(self.TriggerMessageID())
				{
					case 1:
					{
						generators++;
						if (generators == 2)
						{
							kActor @actor = BP::Actor::FindActorWithTID(1011); //Underwater laser door
							actor.TriggerMessageID() = 1;
							actor.TriggerData() = 0;
							actor.Trigger(null);
						}
						break;
					}
					case 2:
					{
						ionCapacitors++;
						if (ionCapacitors == 2)
						{
							kActor @actor = BP::Actor::FindActorWithTID(1008); //Power Station Door
							actor.TriggerMessageID() = 1;
							actor.TriggerData() = 0;
							actor.Trigger(null);
						}
						break;
					}
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
