namespace BP
{
	namespace Actors
	{
		class MusicWav : BP::ScriptActor
		{
			kStr soundPath;
			bool isPlaying;
			//------------------------------------------------------------------------------------------------------------------------
			MusicWav(kActor@ actor)
			{
				super(actor);
				isPlaying = true;
				if (self.Definition() !is null)
				{
					self.Definition().GetString("SoundPath", soundPath);
					self.Definition().GetBool("StartPlaying", isPlaying, true);
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnSerialize(kDict dict)
			{
				SERIALIZE_BOOL(isPlaying);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnDeserialize(kDict& in dict)
			{
				DESERIALIZE_BOOL(isPlaying);
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTrigger(kActor@ pInstigator, const int msg)
			{
				switch(self.TriggerMessageID())
				{
					case 1: //Start
					{
						isPlaying = true;
					}
					case 2: //Stop
					{
						isPlaying = false;
						self.StopLoopingSounds();
					}
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTick() override
			{
				if (isPlaying)
				{
					self.PlayLoopingSound(soundPath);
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
