namespace BP
{
	namespace Actors
	{
		class Pickup : BP::ScriptActor
		{
			float spinSpeed;
			int pickupParticleID;
			int spawnSoundID;
			int spawnParticleID;
			int renderParticleID;
			
			kActor@ lastTouchActor;
			//------------------------------------------------------------------------------------------------------------------------
			Pickup(kActor@ actor)
			{
				super(actor);
				if (self.Definition() !is null)
				{
					self.Definition().GetFloat("BP.spinSpeed", spinSpeed);
					self.Definition().GetInt("BP.pickupParticle", pickupParticleID);
					self.Definition().GetInt("BP.spawnSound", spawnSoundID);
					self.Definition().GetInt("BP.spawnParticle", spawnParticleID);
					self.Definition().GetInt("BP.renderParticle", renderParticleID);
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			~Pickup()
			{
				//if (instigator.Type() == kActor_Player && (instigator.Flags() & AF_DEAD) == 0)
				if (lastTouchActor !is null)
				{
					BP_OnPickup(@lastTouchActor);
					if (pickupParticleID != 0)
					{
						BP::Spawn::Particle(pickupParticleID, @self, self.Origin(), kQuat(self.Pitch(), 0, self.Yaw()));
					}
				}
				if (self.GetTarget() !is null)
				{
					self.GetTarget().CastToParticle().Kill();
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnStart() override
			{
				if (spawnSoundID != 0)
				{
					self.PlaySound(spawnSoundID);
				}
				if (spawnParticleID != 0)
				{
					BP::Spawn::Particle(spawnParticleID, @self, self.Origin(), kQuat(self.Pitch(), 0, self.Yaw()));
				}
				if (renderParticleID != 0)
				{
					kParticle @particle = BP::Spawn::Particle(renderParticleID, @self, self.Origin(), kQuat(self.Pitch(), 0, self.Yaw()));
					self.SetTarget(@particle);
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTouch(kActor@ instigator) override
			{
				@lastTouchActor = @instigator;
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnTick() override
			{
				self.Yaw() += spinSpeed;
			}
			//------------------------------------------------------------------------------------------------------------------------
			void BP_OnPickup(kActor@ actor) {}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
