//BUG: Players get called twice for: spawn, predamage, damage, death. only in multiplayer games (online or offline)

//keep track of last netID that you were
//host sends ids of newly joined players to clients
//if clients current netID is not there lastNetID then swap the PlayerEx values, unless that netID is already in use then stuck with the new netID

//or

//create an MPPlayer class for up to just 1 player for you (can't do all 4 players)


//in offline MP netIDs are always the same
//map defs should be marks with coop and coopstart for the starting map


namespace BP
{	
	//mp mod settings
	float playerGravity = 0.6f; //value for player gravity
	float playerSpeed = 0.5f; //value for friction and air friction
	float playerReceiveDamage = 1.0f; //damege scale the player will Receive
	bool playerCanDoubleJump = false;
	bool playerCanGroundDash = false;
	bool playerCanAirDash = false;
	bool playerCanGroundPound = false;
	bool showPlayerDamage = false;
	bool playerCloaking = false;
	float playerDamage = 1.0f; //the amount of damage players do on ai and players
	kVec3 slapVelocity;
	
	const float PLAYER_AIR_JUMP_VELOCITY = 10.0f;
	const float PLAYER_GROUND_POUND_HEIGHT = 300.0f;
	const float PLAYER_GROUND_POUND_VELOCITY = -60.0f;
	
	const float PLAYER_DASH_LENGTH = 0.4f;
	const float PLAYER_DASH_INPUT_TIME = 0.25f;
	const float PLAYER_DASH_COOLDOWN = 0.5f;

	class Player : BP::ScriptActor
	{
		int airJumpsDone;
		bool wasDead;
		bool wasUnderWater;
		bool wasGrounded;
		bool airDashEnabled;
		bool groundPound;
		float dashInputTime; //double tap dash time (time between inputs)
		float dashCooldown; //time until can dash again
		float dashTimeLength; //How long the dash effect last has left
		float dashForwardSpeed = 8.0f;
		float dashJumpSpeed = 5.0f;
		float dashForwardDirectionX;
		float dashForwardDirectionY;
		float dashLastYawOffset;
		uint16 lastButtons;
		int lastWeaponID = -1;
		bool hasMPActiveTicked; //has the player ticked in MP while being active by a player
		int netID;
		kPuppet@ puppet;
		
		//------------------------------------------------------------------------------------------------------------------------
		Player(kActor @actor)
		{
			super(@actor);
			@puppet = self.CastToPuppet();
		}
		//------------------------------------------------------------------------------------------------------------------------
		~Player()
		{
			BP::Map::OnDestroy();
			Players[netID].OnEndMap(self);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnSerialize(kDict dict) override
		{
			SERIALIZE_FLOAT(dashInputTime);
			SERIALIZE_FLOAT(dashCooldown);
			SERIALIZE_FLOAT(dashTimeLength);
			SERIALIZE_FLOAT(dashForwardSpeed);
			SERIALIZE_FLOAT(dashJumpSpeed);
			SERIALIZE_FLOAT(dashForwardDirectionX);
			SERIALIZE_FLOAT(dashForwardDirectionY);
			
			SERIALIZE_INT(airJumpsDone);
			SERIALIZE_BOOL(wasGrounded);
			SERIALIZE_BOOL(airDashEnabled);
			SERIALIZE_BOOL(wasUnderWater);
			SERIALIZE_BOOL(groundPound);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnDeserialize(kDict& in dict) override
		{
			DESERIALIZE_FLOAT(dashInputTime);
			DESERIALIZE_FLOAT(dashCooldown);
			DESERIALIZE_FLOAT(dashTimeLength);
			DESERIALIZE_FLOAT(dashForwardSpeed);
			DESERIALIZE_FLOAT(dashJumpSpeed);
			DESERIALIZE_FLOAT(dashForwardDirectionX);
			DESERIALIZE_FLOAT(dashForwardDirectionY);

			DESERIALIZE_INT(airJumpsDone);
			DESERIALIZE_BOOL(wasGrounded);
			DESERIALIZE_BOOL(airDashEnabled);
			DESERIALIZE_BOOL(wasUnderWater);
			DESERIALIZE_BOOL(groundPound);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnPreDamage(kDamageInfo& in dmgInfo) override
		{
			if (IsMultiplayer())
			{
				if (!BP::Actor::IsDead(@self))
				{
					kActor @src = @dmgInfo.source;
					float realDamage = dmgInfo.hits;
					
					//Apply damage modifiers
					float moreHits = realDamage * BP::playerReceiveDamage;
					if (src !is null && src.Type() == kActor_Player)
					{
						moreHits *= BP::playerDamage;
					}
					//increase the razorwind damage output in multiplayer for some reason it's really low for players only
					kParticle @particle = dmgInfo.particle;
					if (particle !is null && particle.ParticleType() == kParticle_RazorWind)
					{
						moreHits *= 500.0f;
					}
					
					float hitsDif = moreHits - realDamage;
					self.Health() = MAX(self.Health() - hitsDif, realDamage);
					if (BP::showPlayerDamage)
					{
						ShowDamage(@src, moreHits);
					}
				}
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void TryAirJump()
		{
			//can't double jump or is climbing, or in water
			if (!playerCanDoubleJump || (cWorld.Flags() & (WCF_AT_CLIMBING_SURFACE | WCF_UNDER_WATER | WCF_ON_WATER)) != 0)
			{
				return;
			}
			
			BP::Weapon::ScriptWeapon @weapon = GetCurrentWeaponScript();
			bool doingJump = (puppet.PlayerFlags() & PF_JUMPING) != 0;
			bool hasJumped = (puppet.PlayerFlags() & PF_HASJUMPED) != 0;
			if (!BP::Actor::IsGrounded(@self) && !doingJump && hasJumped && weapon.canDoubleJump && airJumpsDone < 1) //BP::Game::playerMaxAirJumps
			{
				kVec3 vel = cMovement.Velocity();
				cMovement.Velocity() = kVec3(vel.x, vel.y, PLAYER_AIR_JUMP_VELOCITY);
				airJumpsDone++;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void TryGroundPound()
		{
			//can't groundpound or is climbing, or in water
			if (!playerCanGroundPound || (cWorld.Flags() & (WCF_AT_CLIMBING_SURFACE | WCF_UNDER_WATER | WCF_ON_WATER)) != 0)
			{
				return;
			}
			
			BP::Weapon::ScriptWeapon @weapon = GetCurrentWeaponScript();
			if (!groundPound && !BP::Actor::IsGrounded(self) && self.Origin().z >= cWorld.FloorHeight() + PLAYER_GROUND_POUND_HEIGHT &&
				weapon.canStomp)
			{
				groundPound = true;
				puppet.PlayerFlags() |= PF_HASJUMPED;
				airDashEnabled = false;
				cMovement.Velocity() = kVec3(0.0f, 0.0f, PLAYER_GROUND_POUND_VELOCITY);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void TickDash()
		{
			dashInputTime -= GAME_DELTA_TIME;
			dashCooldown -= GAME_DELTA_TIME;
			dashTimeLength -= GAME_DELTA_TIME;
			if (dashTimeLength > 0.0f)
			{
				float speed = Math::Sin((dashTimeLength / PLAYER_DASH_LENGTH) * Math::pi) * dashForwardSpeed;
				cMovement.Velocity() += kVec3(dashForwardDirectionX * speed, dashForwardDirectionY * speed, 0.0f);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		// if is able to dash then dashs in the forward direction + yawOffset of the actor. Returns true if did dash.
		//------------------------------------------------------------------------------------------------------------------------
		bool TryDashInput(float yawOffset)
		{
			bool didDash = false;
			//last input was in the same direction as current input and isn't on cooldown and pressed within a certain time
			if (Math::Approximately(dashLastYawOffset, yawOffset) && dashCooldown <= 0.0f && dashInputTime > 0.0f && dashInputTime < PLAYER_DASH_INPUT_TIME)
			{
				dashInputTime = 0.0f;
				dashCooldown = PLAYER_DASH_COOLDOWN;
				dashTimeLength = PLAYER_DASH_LENGTH;
				cMovement.Velocity().z += dashJumpSpeed;
				dashForwardDirectionX = Math::Sin(self.Yaw() + yawOffset);
				dashForwardDirectionY = Math::Cos(self.Yaw() + yawOffset);
				didDash = true;
			}
			else
			{
				dashInputTime = PLAYER_DASH_INPUT_TIME;
			}
			
			dashLastYawOffset = yawOffset;
			return didDash;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void TryDash(float yawOffset)
		{			
			//climbing, or in water
			if ((cWorld.Flags() & (WCF_AT_CLIMBING_SURFACE | WCF_UNDER_WATER | WCF_ON_WATER)) != 0)
			{
				return;
			}
				
			BP::Weapon::ScriptWeapon @weapon = GetCurrentWeaponScript();
			if (BP::Actor::IsGrounded(self))
			{
				if (!playerCanGroundDash || !weapon.canGroundDash)
				{
					return;
				}
				
				if (dashCooldown <= 0.0f)
				{
					bool didGroundDash = TryDashInput(yawOffset);
					if (didGroundDash)
					{
						self.PlaySound(400); //Talon Swoosh
					}
				}
			}
			else
			{
				if (!playerCanAirDash || !weapon.canAirDash)
				{
					return;
				}
				
				//airDash allowed and dash not on cooldown
				if (airDashEnabled && dashCooldown <= 0.0f)
				{
					bool didAirDash = TryDashInput(yawOffset);
					if (didAirDash)
					{
						
						self.PlaySound(400); //Talon Swoosh
						airDashEnabled = false;
					}
				}
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnGroundedChanged(bool isGrounded)
		{
			if (isGrounded)
			{
				if (groundPound)
				{
					groundPound = false;
					
					BP::Spawn::Particle(BP_Particle_GroundPound, @self, self.Origin() + kVec3(0.0f, 0.0f, 20.0f));
					SpawnShake(kVec3(0, 0, 125.0f), self.Origin(), 10000, true);
				}
				
				airJumpsDone = 0;
				airDashEnabled = true;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnUnderWaterChanged(bool isUnderWater)
		{
			if (groundPound)
			{
				groundPound = false;
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnDeadChanged(bool isDead)
		{
			if (!isDead)
			{
				BP::mapScript.OnPlayerRevive(@self);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::Weapon::ScriptWeapon@ GetCurrentWeaponScript()
		{
			return @BP::Players[netID].weapons[puppet.PlayerOwner().CurrentWeaponID()].script;
		}
		//------------------------------------------------------------------------------------------------------------------------
		void SetPlayerModStats()
		{
			if (IsMultiplayer())
			{
				float gravityResult = 0.6f;
				float speedResult = 0.5f;
				bool cloakResult = false;
				BP::Weapon::ScriptWeapon@ weapon = GetCurrentWeaponScript();
				DebugAssert(weapon !is null, "[BP::Player::SetPlayerModStats] Weapon script is null");
				
				//get modifier values
				gravityResult = MAX(0.0f, BP::playerGravity + weapon.gravity);
				speedResult = Math::Clampf(BP::playerSpeed + weapon.speed, 0.0f, 1.0f);
				cloakResult = BP::playerCloaking;
				
				//apply modifiers
				BP::Actor::SetGravity(@self, gravityResult);
				BP::Actor::SetSpeed(@self, speedResult);
				
				DebugAssert(cRenderMesh !is null, "[BP::Player::SetPlayerModStats] cRenderMesh is null");
				if (cloakResult)
				{
					cRenderMesh.Flags() |= RMCF_CLOAKED;
				}
				else
				{
					cRenderMesh.Flags() &= ~RMCF_CLOAKED;
				}
			}
			else //Singleplayer
			{
				
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Sets the player health/weapons/ammo/inventory to mp settings
		//------------------------------------------------------------------------------------------------------------------------
		void SetupPlayerMP()
		{
			if (BP::Players[netID].mpHealth > 0.0f)
			{
				self.Health() = BP::Players[netID].mpHealth;
			}
			
			#define weapon BP::Players[netID].weapons[i]
			for (int i = 0; i < MAX_WEAPONS; i++)
			{
				if (weapon.mpOwned)
				{
					int curAmmo = puppet.PlayerOwner().GetAmmo(i);
					int ammoAmount = weapon.mpAmmo - curAmmo;
					puppet.PlayerOwner().GiveWeapon(i, ammoAmount);
				}
			}
			#undef weapon
		}
		//------------------------------------------------------------------------------------------------------------------------
		 void BP_OnSpawn() override
		 {
			netID = BP::Actor::NetID(self);
			BP::Map::OnCreate();
			
			//Coop mode only
			if (IsMultiplayer())
			{
				SetupPlayerMP();
			}
			DebugAssert(BP::map !is null, "[BP::Player::BP_OnSpawn] map actor is null");
			BP::mapScript.OnPlayerCreated(@self);
		 }
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnStart() override
		{
		}
		//------------------------------------------------------------------------------------------------------------------------
		void BP_OnTick() override
		{
			bool isDead = BP::Actor::IsDead(@self);
			if (wasDead != isDead)
			{
				OnDeadChanged(isDead);
				wasDead = isDead;
			}

			
			TickDash();
			SetPlayerModStats();
						
			bool isUnderWater = (cWorld.Flags() & WCF_UNDER_WATER) != 0;
			if (wasUnderWater != isUnderWater)
			{
				OnUnderWaterChanged(isUnderWater);
				wasUnderWater = isUnderWater;
			}
			
			bool isGrounded = BP::Actor::IsGrounded(@self);
			if (wasGrounded != isGrounded)
			{
				OnGroundedChanged(isGrounded);
				wasGrounded = isGrounded;
			}
			
			if (groundPound && cMovement.Velocity().z >= 0.0f)
			{
				groundPound = false;
			}
			
			//Tick Weapons
			for (int i = 0; i < MAX_WEAPONS; i++)
			{
				BP::Players[netID].weapons[i].script.OnGameTick();
			}

			int currentWeaponID = puppet.PlayerOwner().CurrentWeaponID();
			if (lastWeaponID != currentWeaponID)
			{
				lastWeaponID = currentWeaponID;
				GetCurrentWeaponScript().OnEquipped();
			}
			
			uint16 buttons = puppet.PlayerOwner().Buttons();
			
			//Tick Input
			if (isDead || !BP::Actor::IsMPPlayerInGame(@self))
			{
				return;
			}
			
			if (BP::Input::ForwardDown(buttons, lastButtons))
			{
				TryDash(0.0f);
			}
			else if (BP::Input::BackwardDown(buttons, lastButtons))
			{
				TryDash(Math::pi);
			}
			
			if (BP::Input::StrafeLeftDown(buttons, lastButtons))
			{
				TryDash(-Math::piHalf);
			}
			else if (BP::Input::StrafeRightDown(buttons, lastButtons))
			{
				TryDash(Math::piHalf);
			}
			
			if (BP::Input::JumpDown(buttons, lastButtons))
			{
				TryAirJump();
			}
			else if (BP::Input::CrouchDown(buttons, lastButtons))
			{
				TryGroundPound();
			}
			
			if (BP::Input::ScopeZoomInDown(buttons, lastButtons))
			{
				//ActorFactory.Spawn(100000, self.Origin(), self.Yaw(), 0, 0);
				//DoPlayerWarp(0, -1, Game.ActiveMapID(), false);
				// kActor@ mission = BP::Actor::FindActorWithTID(6467);
				// if (mission !is null)
				// {
					// mission.SignalOn();
				// }
				// kActor@ eventLink = BP::Actor::FindActorWithTID(6468);
				// if (eventLink !is null)
				// {
					// eventLink.Mark(false);
				// }
				//DoPlayerWarp(const int, const int warpTID, const int mapID = -1, const bool playWarpAnimation = false)
				// for (int i = 0; i < 24; i++)
				// {
					// LocalPlayer.GiveWeapon(i, 999);
				// }
			}
			if (BP::Input::ScopeZoomOutDown(buttons, lastButtons))
			{
				// CinemaPlayer.StartCinema("cinemas/bp/test.txt");
			}
			
			// if (BP::Input::ScopeZoomInDown(buttons, lastButtons))
			// {
				// kActor @actor = BP::Actor::FindActorWithTID(1);
				// actor.TriggerMessageID() = ACTIONOBJECT_MSG_START;
				// actor.TriggerData() = charAnims[interAnim];
				// actor.Trigger(null);
				// Hud.AddMessage("" + charAnims[interAnim]);
				// interAnim++;
				// if (interAnim >= int(charAnims.length()))
				// {
					// interAnim = 0;
				// }
			// }
			// else if (BP::Input::ScopeZoomOutDown(buttons, lastButtons))
			// {
				// kActor @actor = BP::Actor::FindActorWithTID(1);
				// actor.TriggerMessageID() = INTERACTIVE_ANIM_MSG_START;
				// actor.TriggerData() = charAnims[interAnim];
				// actor.Trigger(null);
				// Hud.AddMessage("" + charAnims[interAnim]);
				// interAnim--;
				// if (interAnim < 0)
				// {
					// interAnim = int(charAnims.length()) - 1;
				// }
			// }
			
			lastButtons = buttons;
		}
// array<int> charAnims = {
	// ANIM_INTER_ANIM1,
	// ANIM_INTER_ANIM2,
	// ANIM_INTER_ANIM3,
	// ANIM_INTER_ANIM4,
	// ANIM_INTER_ANIM5,
	// ANIM_INTER_ANIM6,
	// ANIM_INTER_ANIM8,
	// ANIM_INTER_ANIM9,
	// ANIM_INTER_ANIM10,
	// ANIM_INTER_ANIM11,
	// ANIM_INTER_ANIM12,
	// ANIM_INTER_ANIM13,
	// ANIM_INTER_ANIM14
// };

		// int interAnim = 0;
		//------------------------------------------------------------------------------------------------------------------------
	};
}
