namespace BP
{
	array<PlayerEx> Players;
	
	void InitExPlayers()
	{
		Players = array<PlayerEx>(MAX_PLAYERS);
		for (int i = 0; i < MAX_PLAYERS; i++)
		{
			Players[i].netID = i;
		}
	}
	
	class PlayerEx
	{
		int netID;
		//for all map object data mark persisant stuff should keep an array for each map (get all maps aviable in hubinfo def for multiplayer)
		//1 int for entire object (TID is in16, and mark on/off is 1 bit)
		
		array<PlayerExWeapon> weapons; //(MAX_WEAPONS);
		float mpHealth; //actors with < 0 will be restored to full health on start?
		array<int> mpInventory; //filled with Inventory items IDs in no order
		array<int> mpInventoryAmount; //filled with the amount of Inventory items IDs in same order as mpInventory
		
		//------------------------------------------------------------------------------------------------------------------------
		PlayerEx()
		{
			weapons = array<PlayerExWeapon>(MAX_WEAPONS);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void OnEndMap(kActor@ pActor)
		{
			if (IsMultiplayer())
			{
				mpHealth = pActor.Health();
				for (int i = 0; i < MAX_WEAPONS; i++)
				{
					kPlayer player = pActor.CastToPuppet().PlayerOwner();
					if (player.HasWeapon(i))
					{
						weapons[i].mpOwned = true;
					}
					weapons[i].mpAmmo = player.GetAmmo(i);
				}
			}
			
			//cleanup
			for (int i = 0; i < MAX_WEAPONS; i++)
			{
				weapons[i].Destroy();
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr ToString()
		{
			return "";
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
	
	class PlayerExWeapon
	{
		BP::Weapon::ScriptWeapon@ script; //set to null when map finished to stop referencing it
		
		bool mpOwned; //does own this weapon?
		int mpAmmo; //amount of primary ammo for this weapon
		//------------------------------------------------------------------------------------------------------------------------
		PlayerExWeapon()
		{
			
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Destroy()
		{
			@script = null;
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr ToString()
		{
			return "mpOwned: " + mpOwned + " mpAmmo: " + mpAmmo + " script is null: " + (script is null);
		}
		//------------------------------------------------------------------------------------------------------------------------
	};
}
