#include "scripts/BP/Utils/Debug.cpp"

#define BUG_DOUBLE_SCRIPT_CALL 		(self.Type() == kActor_Player && IsMultiplayer()) //set to false to stop fixing bug or delete the relevant code

#define PrintLog(x)									Sys.Print("" + x)
#define PrintError(x)									Sys.Warning("" + x + "\n")

#define SERIALIZE_INT(x)								dict.Add(#x, ""+x)
#define SERIALIZE_FLOAT(x)						dict.Add(#x, ""+x)
#define SERIALIZE_BOOL(x)							dict.Add(#x, ""+x)
#define SERIALIZE_STRING(x)						dict.Add(#x, x)
#define SERIALIZE_VECTOR(x)						dict.Add(#x, x.ToString())
#define DESERIALIZE_STRING(x)					dict.GetString(#x, x)
#define DESERIALIZE_VECTOR(x)					dict.GetVector(#x, x)

#define SERIALIZEKEY_INT(key, x)				dict.Add(key, ""+x)
#define SERIALIZEKEY_FLOAT(key, x)			dict.Add(key, ""+x)
#define SERIALIZEKEY_BOOL(key, x)             dict.Add(key, ""+x)
#define SERIALIZEKEY_STRING(key, x)			dict.Add(key, x)
#define SERIALIZEKEY_VECTOR(key, x)         dict.Add(key, x.ToString())
#define DESERIALIZEKEY_FLOAT(key, x)		dict.GetFloat(key, x)
#define DESERIALIZEKEY_INT(key, x)			dict.GetInt(key, x)
#define DESERIALIZEKEY_BOOL(key, x)         x = DeserializeBool(dict, key)
#define DESERIALIZEKEY_STRING(key, x)		dict.GetString(key, x)
#define DESERIALIZEKEY_VECTOR(key, x)		dict.GetVector(key, x)

#define SERIALIZEARRAY_INT(ary)				SerializeArrayInt(dict, #ary, ary)
#define DESERIALIZEARRAY_INT(ary)			DeserializeArrayInt(dict, #ary, ary)
#define SERIALIZEARRAY_FLOAT(ary)			SerializeArrayFloat(dict, #ary, ary)
#define DESERIALIZEARRAY_FLOAT(ary)		DeserializeArrayFloat(dict, #ary, ary)

void SerializeArrayInt(kDict& in dict, kStr& in key, const array<int>& ary)
{
	int length = int(ary.length());
	SERIALIZEKEY_INT(key + "L", length);
	for (int i = 0; i < length; i++)
	{
		SERIALIZEKEY_INT(key + i, ary[i]);
	}
}
			
void DeserializeArrayInt(kDict& in dict, kStr& in key, array<int>& ary)
{
	int length;
	DESERIALIZEKEY_INT(key + "L", length);
	ary.resize(length);
	for (int i = 0; i < length; i++)
	{
		DESERIALIZEKEY_INT(key + i, ary[i]);
	}
}

void SerializeArrayFloat(kDict& in dict, kStr& in key, const array<float>& ary)
{
	int length = int(ary.length());
	SERIALIZEKEY_INT(key + "L", length);
	for (int i = 0; i < length; i++)
	{
		SERIALIZEKEY_FLOAT(key + i, ary[i]);
	}
}
			
void DeserializeArrayFloat(kDict& in dict, kStr& in key, array<float>& ary)
{
	int length;
	DESERIALIZEKEY_INT(key + "L", length);
	ary.resize(length);
	for (int i = 0; i < length; i++)
	{
		DESERIALIZEKEY_FLOAT(key + i, ary[i]);
	}
}

#define MAX_PLAYERS 16
#define QUAT_IDENTITY kQuat(0.0f, 0.0f, 0.0f)
#define VEC_ZERO Math::vecZero

#define FOREACH_ACTOR \
	kActorIterator iter; \
	kActor@ actor; \
	while ((@actor = iter.GetNext()) !is null)
		
#define IsNetServer (Network.IsNetgame() && Network.IsServer())
#define IsNetClient (Network.IsNetgame() && Network.IsClient())

#define NET_SYNC_TIME 0.033333f

#define USEREVENT_MSG_GET_SCRIPT				100


#define USEREVENT_MSG_ACTOR_NETRECEIVE	110

#define TRIGGER_MSG_HEALTHBAR			10

#define MP_GAMEMODE_ROK					1
#define MP_GAMEMODE_TEAMROK			2
#define MP_GAMEMODE_FRAGTAG			3
#define MP_GAMEMODE_LASTSTANDING	4
#define MP_GAMEMODE_ROKMIX				5
#define MP_GAMEMODE_INSTAROK			6
#define MP_GAMEMODE_RAPTORFEST		7

#include "defs/BP/common.cpp"

#include "scripts/BP/Utils/Math.cpp"
#include "scripts/BP/Utils/String.cpp"
#include "scripts/BP/Utils/Array.cpp"
#include "scripts/BP/Utils/Actor.cpp"
#include "scripts/BP/Utils/Input.cpp"
#include "scripts/BP/Utils/Spawn.cpp"
#include "scripts/BP/Utils/UserEvent.cpp"
#include "scripts/BP/Utils/Inventory.cpp"
#include "scripts/BP/Utils/Cvars.cpp"
#include "scripts/BP/Utils/Map.cpp"
#include "scripts/BP/Utils/Hud.cpp"
#include "scripts/BP/Utils/Audio.cpp"
#include "scripts/BP/Utils/Game.cpp"

#include "scripts/BP/Defs/Weapon.cpp"

#include "scripts/BP/Actors/ScriptActor.cpp"
#include "scripts/BP/Actors/Player.cpp"
#include "scripts/BP/Actors/MoveablePlatform.cpp"
#include "scripts/BP/Actors/MusicWav.cpp"
#include "scripts/BP/Actors/DifficultyCheck.cpp"
#include "scripts/BP/Actors/EventListener.cpp"
#include "scripts/BP/Actors/Destructible.cpp"
#include "scripts/BP/Actors/Action.cpp"
#include "scripts/BP/Actors/InteractiveAnim.cpp"
#include "scripts/BP/Actors/Door.cpp"
#include "scripts/BP/Actors/AISpawnPoint.cpp"
#include "scripts/BP/Actors/MoverBlocker.cpp"

#include "scripts/BP/Actors/Pickups/Pickup.cpp"
#include "scripts/BP/Actors/Pickups/PickupInventory.cpp"

// #include "scripts/BP/UI/Element.cpp"
// #include "scripts/BP/UI/ScriptElement.cpp"
// #include "scripts/BP/UI/UI.cpp"
// #include "scripts/BP/UI/Window.cpp"

#include "scripts/BP/Actors/AI/AI.cpp"
#include "scripts/BP/Actors/AI/Primagen.cpp"
#include "scripts/BP/Actors/AI/Queen.cpp"
#include "scripts/BP/Actors/AI/AraissiSoldier.cpp"
#include "scripts/BP/Actors/AI/BioBot.cpp"
#include "scripts/BP/Actors/AI/BlindGuardian.cpp"
#include "scripts/BP/Actors/AI/BlindSentinel.cpp"
#include "scripts/BP/Actors/AI/CaveSpider.cpp"
#include "scripts/BP/Actors/AI/CaveWorm.cpp"
#include "scripts/BP/Actors/AI/Compsognathus.cpp"
#include "scripts/BP/Actors/AI/Deadman.cpp"
#include "scripts/BP/Actors/AI/DeadmanHalf.cpp"
#include "scripts/BP/Actors/AI/DeathGuard.cpp"
#include "scripts/BP/Actors/AI/Endtrail.cpp"
#include "scripts/BP/Actors/AI/Fireborn.cpp"
#include "scripts/BP/Actors/AI/FleshSentinel.cpp"
#include "scripts/BP/Actors/AI/FleshWorm.cpp"
#include "scripts/BP/Actors/AI/Grub.cpp"
#include "scripts/BP/Actors/AI/HiveDrone.cpp"
#include "scripts/BP/Actors/AI/HiveSoldier.cpp"
#include "scripts/BP/Actors/AI/HiveWorker.cpp"
#include "scripts/BP/Actors/AI/Leaper.cpp"
#include "scripts/BP/Actors/AI/LordoftheDead.cpp"
#include "scripts/BP/Actors/AI/LordoftheFlesh.cpp"
#include "scripts/BP/Actors/AI/Mite.cpp"
#include "scripts/BP/Actors/AI/MotherGrub.cpp"
#include "scripts/BP/Actors/AI/Nala.cpp"
#include "scripts/BP/Actors/AI/PrimagenDrone.cpp"
#include "scripts/BP/Actors/AI/PrimagenGuard.cpp"
#include "scripts/BP/Actors/AI/PrimagenTrooper.cpp"
#include "scripts/BP/Actors/AI/PurlinGunner.cpp"
#include "scripts/BP/Actors/AI/PurlinJuggernaut.cpp"
#include "scripts/BP/Actors/AI/PurlinWarClub.cpp"
#include "scripts/BP/Actors/AI/Raptoid.cpp"
#include "scripts/BP/Actors/AI/Raptor.cpp"
#include "scripts/BP/Actors/AI/SisterofDespair.cpp"
#include "scripts/BP/Actors/AI/SpiderHatchling.cpp"
#include "scripts/BP/Actors/AI/SwampWasp.cpp"

#include "scripts/BP/Actors/Maps/ScriptMap.cpp"
#include "scripts/BP/Actors/Maps/HUB.cpp"
#include "scripts/BP/Actors/Maps/HUB2.cpp"
#include "scripts/BP/Actors/Maps/Palace.cpp"
#include "scripts/BP/Actors/Maps/Port1.cpp"
#include "scripts/BP/Actors/Maps/Port2.cpp"

#include "scripts/BP/Actors/Controllers/Flare.cpp"
#include "scripts/BP/Actors/Controllers/RazorWind.cpp"
#include "scripts/BP/Actors/Controllers/QuadMissileLauncher.cpp"
#include "scripts/BP/Actors/Controllers/CerebralBore.cpp"
#include "scripts/BP/Actors/Controllers/WorldChar.cpp"

#include "scripts/BP/Weapons/ScriptWeapon.cpp"
#include "scripts/BP/Weapons/Bow.cpp"
#include "scripts/BP/Weapons/CerebralBore.cpp"
#include "scripts/BP/Weapons/ChargeDart.cpp"
#include "scripts/BP/Weapons/FireStormCannon.cpp"
#include "scripts/BP/Weapons/FlameThrower.cpp"
#include "scripts/BP/Weapons/Flare.cpp"
#include "scripts/BP/Weapons/GrenadeLauncher.cpp"
#include "scripts/BP/Weapons/Harpoon.cpp"
#include "scripts/BP/Weapons/Mag60.cpp"
#include "scripts/BP/Weapons/Nuke.cpp"
#include "scripts/BP/Weapons/PFMLayer.cpp"
#include "scripts/BP/Weapons/Pistol.cpp"
#include "scripts/BP/Weapons/PlasmaRifle.cpp"
#include "scripts/BP/Weapons/QuadMissileLauncher.cpp"
#include "scripts/BP/Weapons/RaptorClaws.cpp"
#include "scripts/BP/Weapons/RazorWind.cpp"
#include "scripts/BP/Weapons/RidingGun.cpp"
#include "scripts/BP/Weapons/Shotgun.cpp"
#include "scripts/BP/Weapons/Shredder.cpp"
#include "scripts/BP/Weapons/SunfirePod.cpp"
#include "scripts/BP/Weapons/Talons.cpp"
#include "scripts/BP/Weapons/TekBow.cpp"
#include "scripts/BP/Weapons/TorpedoLauncher.cpp"
#include "scripts/BP/Weapons/Tranquilizer.cpp"
#include "scripts/BP/Weapons/WarBlade.cpp"
#include "scripts/BP/Weapons/AssaultRifleMP.cpp"
#include "scripts/BP/Weapons/CerebralBoreMP.cpp"
#include "scripts/BP/Weapons/ChargeDartMP.cpp"
#include "scripts/BP/Weapons/CrossbowMP.cpp"
#include "scripts/BP/Weapons/FireStormCannonMP.cpp"
#include "scripts/BP/Weapons/GrenadeLauncherMP.cpp"
#include "scripts/BP/Weapons/PlasmaRifleMP.cpp"
#include "scripts/BP/Weapons/QuadMissileLauncherMP.cpp"

#include "scripts/BP/Server/ConsoleCommands.cpp"
#include "scripts/BP/Server/NetworkCommands.cpp"

#include "scripts/BP/ExPlayer.cpp"

void BP_Main()
{
	BP::String::LoadDefs();
	BP::Def::LoadWeapons();
	BP::InitExPlayers();
}
