#include <Array.au3>
#include <File.au3>
#include <MsgBoxConstants.au3>

Global $sMyContent = "//Auto Generated" & @CRLF
Global $sHelpContent = "void help()" & @CRLF & "{" & @CRLF
Global $sQuote = '"'

$sHelpContent &= @TAB & "PrintLog(" & $sQuote & "----------Mod Commands----------" & $sQuote & ");" & @CRLF;
$sHelpContent &= @TAB & "PrintError(" & $sQuote & "call showmods (Displays a list of the current servers mod settings)\n" & $sQuote & ");" & @CRLF;
$sHelpContent &= @TAB & "PrintLog(" & $sQuote & "---------Server Commands--------" & $sQuote & ");" & @CRLF;

CreateFloat2Commands("grav", "SetGravity", 0.0, 1.0, 0.01, "Sets gravity. Default value 60")
CreateFloat2Commands("speed", "SetSpeed", 0.0, 1.0, 0.01, "Sets player speed. Default value 50")
CreateFloat1Commands("dmg", "SetDamage", 0.0, 10.0, 0.1, "Sets the damage scale that players deal out. Default value 10")
CreateIntCommands("dmg", "SetDamage", 1000, 1000, 1, "Sets the damage scale that players deal out to 1000 aka insta kill")
CreateBoolCommands("dmgshow", "SetShowPlayerDamage", "Turns %s damage number popups")
CreateFloat1Commands("def", "SetReceiveDamage", 0.0, 10.0, 0.1, "Sets how much scaled damage players will receive. Default value 10")
CreateIntCommands("def", "SetReceiveDamage", 1000, 1000, 1, "Sets how much scaled damage players will receive to 1000 aka 1 hit death")
CreateBoolCommands("jump", "SetDoubleJump", "Turns %s Double Jump ability")
CreateBoolCommands("dash", "SetGroundDash", "Turns %s Ground Dash ability")
CreateBoolCommands("airdash", "SetAirDash", "Turns %s Air Dash ability")
CreateBoolCommands("slam", "SetGroundPound", "Turns %s Ground Slam ability")
CreateBoolCommands("cloak", "SetPlayerCloak", "Turns %s players cloaking")
CreateIntCommands("slap", "slap", 0, 15, 1, "Slaps a player with id. Type playeridx to find the player id to slap")

$sHelpContent &= @TAB & "PrintLog(" & $sQuote & $sQuote & ");" & @CRLF;
$sHelpContent &= "}" & @CRLF
$file = FileOpen("ConsoleCommands.cpp", 2)
FileWrite($file, $sMyContent & $sHelpContent)
FileClose($file)

Func CreateFloat1Commands($name, $fName, $min, $max, $step, $help)
   Local $value = $min
   Do
	  CreateFloat1Command($name, $fName, $value)
	  $value += $step
   Until $value >= $max
   $sMyContent &= @CRLF
   $iMin = Round($min * 10)
   $iMax = Round($max * 10)
   $helpString = StringFormat(" (%s)", $help)
   $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $iMin & " .. " & $iMax & $helpString & $sQuote & ");" & @CRLF;
EndFunc

Func CreateFloat1Command($name, $fName, $value)
   $decValueString = StringFormat("%.1f", $value)
   $funcDecValueString = Round($value * 10)
   $sMyContent &= "void " & $name & $funcDecValueString & "(){" & $fName & "(" & $decValueString & "f);}"
EndFunc

Func CreateFloat2Commands($name, $fName, $min, $max, $step, $help)
   Local $value = $min
   Do
	  CreateFloat2Command($name, $fName, $value)
	  $value += $step
   Until $value >= $max + $step
   $sMyContent &= @CRLF
   $iMin = Round($min * 100)
   $iMax = Round($max * 100)
   $helpString = StringFormat(" (%s)", $help)
   $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $iMin & " .. " & $iMax & $helpString & $sQuote & ");" & @CRLF;
EndFunc

Func CreateFloat2Command($name, $fName, $value)
   $decValueString = StringFormat("%.2f", $value)
   $funcDecValueString = Round($value * 100)
   $sMyContent &= "void " & $name & $funcDecValueString & "(){" & $fName & "(" & $decValueString & "f);}"
EndFunc

Func CreateIntCommands($name, $fName, $min, $max, $step, $help)
   For $value = $min To $max Step $step
	  CreateIntCommand($name, $fName, $value)
   Next
   $sMyContent &= @CRLF
   $helpString = StringFormat(" (%s)", $help)
   If ($min == $max) Then
	  $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $min & $helpString & $sQuote & ");" & @CRLF;
   Else
	  $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $min & " .. " & $max & $helpString & $sQuote & ");" & @CRLF;
   EndIf
EndFunc

Func CreateIntCommand($name, $fName, $value)
   $sMyContent &= "void " & $name & $value & "(){" & $fName & "(" & $value & ");}"
EndFunc

Func CreateBoolCommands($name, $fName, $help)
   CreateBoolCommand($name, $fName, true, $help)
   CreateBoolCommand($name, $fName, false, $help)
   $sMyContent &= @CRLF
EndFunc

Func CreateBoolCommand($name, $fName, $value, $help)
   $funcValue = $value == true ? "on" : "off"
   $boolValue = $value == true ? "true" : "false"
   $sMyContent &= "void " & $name & $funcValue & "(){" & $fName & "(" & $boolValue & ");}"
   $helpString = StringFormat(" (" & $help & ")", $funcValue)
   $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $funcValue & $helpString & $sQuote & ");" & @CRLF;
EndFunc

Func CreateCommand($name, $fName, $help)
   $sMyContent &= "void " & $name & "(){" & $fName & "();}"
   $helpString = StringFormat(" (%s)", $help)
   $sHelpContent &= @TAB & "PrintError(" & $sQuote & "call " & $name & $helpString & $sQuote & ");" & @CRLF;
EndFunc
