#define BP_DEBUG	//comment out to prevent debug messages
	
#ifdef BP_DEBUG
    #define DebugLog(x)			Sys.Print("" + x)
    #define DebugError(x)			Sys.Warning("" + x + "\n")
	#define DebugLogThis(x)		DebugLog(#x + " = " + x)
	#define DebugLogIsNull(x)		DebugLog(#x + " is null = " + (x is null))
	#define DebugLogActor(x)	(x is null) ? DebugLog(#x + " is null") : DebugLog(#x + " is type " + x.Type())
    #define DebugLogAssert(x)	DebugError("[ASSERT] " + x)
	namespace BP
	{
		namespace Debug
		{
			//------------------------------------------------------------------------------------------------------------------------
			void Assertion_Failed_Check_stdout_File_For_Details_Right_Now(bool condition, const kStr& in message)
			{
				if (!condition)
				{
					DebugLogAssert(message);
					array<int> doCrash = { doCrash[0] }; //Crash game and exit with decent runtime error message
				}
			}
			//------------------------------------------------------------------------------------------------------------------------
			void Flags(kActor @actor)
			{
				kStr mcText;
				kMovementComponent @mc = actor.MovementComponent();
				if (mc !is null)
				{
					mcText = " MoveFlags: " + mc.Flags() + " MoveClipFlags: " + mc.ClipFlags();
				}
				kStr modeText;
				kModeStateComponent @mode = actor.ModeStateComponent();
				if (mode !is null)
				{
					modeText = " Mode: " + mode.Mode() + " PrevMode: " + mode.PrevMode();
				}
				kStr worldText;
				kWorldComponent @world = actor.WorldComponent();
				if (world !is null)
				{
					worldText = " WorldFlags: " + world.Flags();
				}
				kStr animText;
				kAnimTrackComponent @anim = actor.AnimTrackComponent();
				if (anim !is null)
				{
					animText = " AnimFlags: " + anim.Flags() + " AnimMoveClipFlags: " + anim.MovementClipFlags();
					
				}
				kStr rmText;
				kRenderMeshComponent @rm = actor.RenderMeshComponent();
				if (rm !is null)
				{
					rmText = " RenderMeshFlags: " + rm.Flags() + " RenderMeshFxFlags: " + rm.FxFlags();
				}
				kStr aiText;
				kEnemyAIComponent @ai = actor.EnemyAIComponent();
				if (ai !is null)
				{
					aiText = " EnemyCommonFlags: " + ai.CommonFlags() + " EnemySpawnFlags: " + ai.SpawnFlags();
				}
				kStr playerText;
				if (actor.InstanceOf("kexPuppet"))
				{
					kPuppet @puppet = actor.CastToPuppet();
					playerText = " PlayerFlags: " + puppet.PlayerFlags();
				}
				DebugLog("ActorFlags: " + actor.Flags() + worldText + modeText + mcText + animText + rmText + aiText + playerText);
			}
			//------------------------------------------------------------------------------------------------------------------------
		}
	}
	#define DebugAssert(condition, message)	BP::Debug::Assertion_Failed_Check_stdout_File_For_Details_Right_Now(condition, message)
	#define DebugFlags(actor) BP::Debug::Flags(actor)
#else
    #define DebugLog(x)
    #define DebugError(x)
	#define DebugLogThis(x)
	#define DebugLogIsNull(x)
	#define DebugLogAssert(x)
	#define DebugAssert(x, y)
	#define DebugLogActor(x)
	#define DebugFlags(actor)
#endif
