namespace BP
{
	namespace Input
	{
		const int BC_CROUCH = 1 << 6;
		
		//------------------------------------------------------------------------------------------------------------------------
		// Returns true while the button is held down
		//------------------------------------------------------------------------------------------------------------------------
		bool Crouch(const uint16 buttons)
		{
			return (buttons & BC_CROUCH) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Returns true during the frame the user pressed down the button
		//------------------------------------------------------------------------------------------------------------------------
		bool CrouchDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_CROUCH) == 0 && (buttons & BC_CROUCH) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Returns true the first frame the user releases the button
		//------------------------------------------------------------------------------------------------------------------------
		bool CrouchUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_CROUCH) != 0 && (buttons & BC_CROUCH) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Attack(const uint16 buttons)
		{
			return (buttons & BC_ATTACK) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool AttackDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_ATTACK) == 0 && (buttons & BC_ATTACK) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool AttackUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_ATTACK) != 0 && (buttons & BC_ATTACK) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool AltFireDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_ALTFIRE) == 0 && (buttons & BC_ALTFIRE) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Jump(const uint16 buttons)
		{
			return (buttons & BC_JUMP) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool JumpDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_JUMP) == 0 && (buttons & BC_JUMP) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool JumpUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_JUMP) != 0 && (buttons & BC_JUMP) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Forward(const uint16 buttons)
		{
			return (buttons & BC_FORWARD) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ForwardDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_FORWARD) == 0 && (buttons & BC_FORWARD) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ForwardUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_FORWARD) != 0 && (buttons & BC_FORWARD) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Backward(const uint16 buttons)
		{
			return (buttons & BC_BACKWARD) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool BackwardDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_BACKWARD) == 0 && (buttons & BC_BACKWARD) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool BackwardUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_BACKWARD) != 0 && (buttons & BC_BACKWARD) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeLeft(const uint16 buttons)
		{
			return (buttons & BC_STRAFELEFT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeLeftDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_STRAFELEFT) == 0 && (buttons & BC_STRAFELEFT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeLeftUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_STRAFELEFT) == 0 && (buttons & BC_STRAFELEFT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeRight(const uint16 buttons)
		{
			return (buttons & BC_STRAFERIGHT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeRightDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_STRAFERIGHT) == 0 && (buttons & BC_STRAFERIGHT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool StrafeRightUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_STRAFERIGHT) != 0 && (buttons & BC_STRAFERIGHT) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomIn(const uint16 buttons)
		{
			return (buttons & BC_SCOPEZOOMIN) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomInDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_SCOPEZOOMIN) == 0 && (buttons & BC_SCOPEZOOMIN) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomInUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_SCOPEZOOMIN) != 0 && (buttons & BC_SCOPEZOOMIN) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomOut(const uint16 buttons)
		{
			return (buttons & BC_SCOPEZOOMOUT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomOutDown(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_SCOPEZOOMOUT) == 0 && (buttons & BC_SCOPEZOOMOUT) != 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool ScopeZoomOutUp(const uint16 buttons, const uint16 lastButtons)
		{
			return (lastButtons & BC_SCOPEZOOMOUT) != 0 && (buttons & BC_SCOPEZOOMOUT) == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------	
	}
}
