namespace BP
{
	namespace Inventory
	{
//		array<array<int>> mpAmmos(MAX_PLAYERS, array<int>(MAX_WEAPONS)); //players and there amount of primary ammo they have 
//		array<array<int>> mpWeapons(MAX_PLAYERS, array<int>(MAX_WEAPONS)); //players and there weapons IDs they have
//		array<array<int>> mpInventory(MAX_PLAYERS, array<int>(MP_MAX_INVENTORY)); //players and there Inventory items IDs they have
		
		//------------------------------------------------------------------------------------------------------------------------
		void GiveWeapon(const int weaponID, const int ammoAmount, kPlayer player = LocalPlayer)
		{
			player.GiveWeapon(weaponID, ammoAmount);
			
			if (IsMultiplayer())
			{
				int netID = BP::Actor::NetID(player.Actor().CastToActor());
				DebugAssert(weaponID >= 0 && weaponID < int(BP::Players[netID].weapons.length()), "[BP::Inventory::GiveWeapon] weaponID of " + weaponID + " is out of range from array length " + int(BP::Players[netID].weapons.length()) + " with netID of " + netID);
				BP::Players[netID].weapons[weaponID].mpOwned = true;
				BP::Players[netID].weapons[weaponID].mpAmmo = player.GetAmmo(weaponID);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Take Primary ammo from a weapon. Does nothing if player doesn't have the weapon or if has max ammo.
		//------------------------------------------------------------------------------------------------------------------------
		void TakeAmmo(const int weaponID, const int amount, kPlayer player = LocalPlayer)
		{
			//if doesn't have the weapon then doesn't do anything
			if (!player.HasWeapon(weaponID))
			{
				return;
			}
			
			//if weaponID is current weapon then just use consume ammo
			if (player.CurrentWeaponID() == weaponID)
			{
				player.ConsumeAmmo(amount);
				return;
			}
			
			//if theres no ammo to take then do nothing
			int ammo = player.GetAmmo(weaponID);
			if (ammo <= 0)
			{
				return;
			}

			//TODO: Find some way to reduce ammo with max ammo (don't think there currently is a way)
			
			//overflow ammo amount to reduce it
			player.GiveWeapon(weaponID, 2147483647);
			player.GiveWeapon(weaponID, 2147483649 - amount);
			
			//Make sure current ammo is not less than 0
			ammo = player.GetAmmo(weaponID);
			if (ammo < 0)
			{
				player.GiveWeapon(weaponID, Math::Abs(ammo));
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Give(int itemID, int amount, kPlayer player = LocalPlayer)
		{
			for (int i = 0; i < amount; i++)
			{
				player.Inventory().Give(itemID);
//				if (IsMultiplayer())
//				{
//					int netID = player.Actor().NetID();
//					DebugAssert(netID < 0 || netID >= int(mpInventory.length()), "[BP::Inventory::Give] netID of " + netID + " is out of range from array length " + int(mpInventory.length()) + " with itemID of " + itemID);
//					DebugAssert(itemID < 0 || itemID >= int(mpInventory[netID].length()), "[BP::Inventory::Give] itemID of " + itemID + " is out of range from array length " + int(mpInventory[netID].length()) + " with netID of " + netID);
//					mpInventory[netID][itemID]++;
//				}
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Take(int itemID, int amount, kPlayer player = LocalPlayer)
		{
			for (int i = 0; i < amount; i++)
			{
				player.Inventory().Take(itemID);
//				if (IsMultiplayer())
//				{
//					int netID = player.Actor().NetID();
//					DebugAssert(netID < 0 || netID >= int(mpInventory.length()), "[BP::Inventory::Take] netID of " + netID + " is out of range from array length " + int(mpInventory.length()) + " with itemID of " + itemID);
//					DebugAssert(itemID < 0 || itemID >= int(mpInventory[netID].length()), "[BP::Inventory::Take] itemID of " + itemID + " is out of range from array length " + int(mpInventory[netID].length()) + " with netID of " + netID);
//					mpInventory[netID][itemID]--;
//				}
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Has(int itemID, int amount = 1, kPlayer player = LocalPlayer)
		{
			return GetCount(itemID, player) >= amount;
		}
		//------------------------------------------------------------------------------------------------------------------------
		int GetCount(int itemID, kPlayer player = LocalPlayer)
		{
			return player.Inventory().GetCount(itemID);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Clear(kPlayer player = LocalPlayer)
		{
			player.Inventory().Reset();
//			if (IsMultiplayer())
//			{
//				int netID = player.Actor().NetID();
//				DebugAssert(netID < 0 || netID >= int(mpInventory.length()), "[BP::Inventory::Clear] netID of " + netID + " is out of range from array length " + int(mpInventory.length()));
//				for (int i = 0; i < int(mpInventory[netID].length()); i++)
//				{
//					mpInventory[netID][i] = 0;
//				}
//			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
