namespace BP
{
	namespace Spawn
	{
		//------------------------------------------------------------------------------------------------------------------------
		kParticle@ Particle(const int particleID, kActor@ actor, const kVec3&in origin = Math::vecZero, const kQuat&in rotation = QUAT_IDENTITY)
		{
			return ParticleFactory.Spawn(particleID, @actor, origin, rotation, Math::vecZero);
		}
		//------------------------------------------------------------------------------------------------------------------------
		kParticle@ Particle(const kStr&in path, kActor@ owner, const kVec3&in origin = Math::vecZero, const kQuat&in rotation = QUAT_IDENTITY)
		{
			kParticle @particle = ParticleFactory.Spawn(path, @owner, rotation, Math::vecZero);
			if (particle !is null)
			{
				particle.Origin() = origin;
			}
			return @particle;
		}
		//------------------------------------------------------------------------------------------------------------------------
		kActor@ Actor(const int32 actorID, const kVec3& in origin, const float yaw = 0.0f)
		{
			return ActorFactory.Spawn(actorID, origin, yaw, 0.0f, 0.0f);
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
