namespace BP
{
	namespace String
	{
		array<kStr> asciiChars = {
			"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
			"", "", ' ', '!', '"', "", "", '%', '&', '\'', '(', ')', '*', '+', ',', '-', ".", "/", '0', '1', '2', '3', '4', '5', '6',
			'7', '8', '9', ':', ';', '<', '=', '>', '?', '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N',
			'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z', '[', '\\', ']', '^', '_', '`', 'a', 'b', 'c', 'd', 'e', 'f',
			'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z', '{', '|', '}', '~', ""
		};
		
		//------------------------------------------------------------------------------------------------------------------------
		int Length(kStr &in s)
		{
			kStr key = ";L;";
			s += key;
			return s.IndexOf(key);
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool Equals(kStr &in s, kStr &in s2)
		{
			return s.Hash() == s2.Hash();
		}
		//------------------------------------------------------------------------------------------------------------------------
		bool IsEmpty(kStr &in s)
		{
			return s.Hash() == 0;
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr CharAt(kStr &in s, int index)
		{
			int8 c = s[index];
			return c >= 0 ? asciiChars[c] : "";
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr CharHash()
		{
			return asciiChars[35];
		}
		//------------------------------------------------------------------------------------------------------------------------
		kStr CharDollar()
		{
			return asciiChars[36];
		}
		//------------------------------------------------------------------------------------------------------------------------
		void GetAsciiCharDef(kDictMem@ dictMem, kStr &in key, const int asciiIndex)
		{
			kStr s;
			if (dictMem.GetString(key, s))
			{
				asciiChars[asciiIndex] = s;
			}
			else
			{
				DebugAssert(false, "[BP::String::GetAsciiCharDef] '" + key + "' not found in 'defs/BP/strings.cpp'");
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		// Loads a def of strings that can't be typed in scripts but can be placed in variables and used
		//------------------------------------------------------------------------------------------------------------------------
		void LoadDefs()
		{
			kDefManager defManager;
			defManager.LoadFile("defs/BP/strings.cpp");
			kDictMem@ dictMem = defManager.GetEntry("Strings");
			DebugAssert(dictMem !is null, "[BP::String::LoadDefs] Could not find 'Strings' entry in 'defs/BP/strings.cpp' def manager");
			GetAsciiCharDef(dictMem, "Hash", 35);
			GetAsciiCharDef(dictMem, "Dollar", 36);
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
