namespace BP
{
	namespace UserEvent
	{
		BP::ScriptActor@ scriptResult;
		
		//------------------------------------------------------------------------------------------------------------------------
		void ActorNetReceive(kActor@ actor, array<int>& int32Args, array<int16>& int16Args)
		{
			BP::ScriptActor@ script = BP::UserEvent::GetScript(@actor);
			if (script !is null)
			{
				script.BP_OnNetReceive(int32Args, int16Args);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::ScriptActor@ GetScript(kActor@ actor)
		{
			@scriptResult = null;
			Call(@actor, USEREVENT_MSG_GET_SCRIPT);
			BP::ScriptActor@ result = @scriptResult;
			@scriptResult = null;
			return @result;
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::AI@ GetAIScript(kActor@ actor)
		{
			BP::ScriptActor@ script = GetScript(@actor);
			return cast<BP::AI>(script);
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::Player@ GetPlayerScript(kActor@ actor)
		{
			BP::ScriptActor@ script = GetScript(@actor);
			return cast<BP::Player>(script);
		}
		//------------------------------------------------------------------------------------------------------------------------
		BP::WorldChar@ GetCharScript(kActor@ actor)
		{
			BP::ScriptActor@ script = GetScript(@actor);
			return cast<BP::WorldChar>(script);
		}
		//------------------------------------------------------------------------------------------------------------------------
		void Call(kActor @actor, const int msg)
		{
			if (actor !is null)
			{
				Event.RunAction(actor, null, ACTION_USER, Math::vecZero, msg, 0, 0, 0);
			}
			else
			{
				DebugError("[BP::UserEvent::Call] actor is null with msg " + msg);
			}
		}
		//------------------------------------------------------------------------------------------------------------------------
	}
}
