namespace BP
{
	namespace Weapon
	{
		abstract class ScriptWeapon : ScriptObject
		{
			kWeapon @self;
			int id;
			uint16 buttons;
			uint16 lastButtons;
			bool canStomp = true;
			bool canGroundDash = true;
			bool canAirDash = true;
			bool canDoubleJump = true;
			float gravity = 0.0f; //how much gravity to add to the player when equipped
			float speed = 0.0f; //how much speed to add to the player when equipped
			//------------------------------------------------------------------------------------------------------------------------
			ScriptWeapon(kWeapon @actor)
			{
				@self = actor;
				
				#ifdef BP_DEBUG
				if (!BP::Array::IndexInRange(MAX_WEAPONS, id))
				{
					DebugError("[ScriptWeapon .ctor] Weapon ID of " + id + " is not in range from 0 to " + (MAX_WEAPONS - 1));
					return;
				}
				#endif
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnTick()
			{
				//if has haste
				//self.AnimTrackComponent().ChangeSpeed(2.0f);
				
				// switch (self.AnimTrackComponent().PlayingID())
				// {
					// case ANIM_WPN_ENTER:
					// case ANIM_WPN_EXIT:
					// case ANIM_WPN_LASTAMMOEXIT:
					// case ANIM_WPN_UNDERWATER_ENTER:
					// case ANIM_WPN_UNDERWATER_EXIT:
					// case ANIM_WPN_UNDERWATER_LASTAMMOEXIT:
					// {
						// self.AnimTrackComponent().ChangeSpeed(2.0f);
						// break;
					// }
					// case ANIM_WPN_ATK1:
					// case ANIM_WPN_ATK2:
					// case ANIM_WPN_ATK3:
					// case ANIM_WPN_ATK4:
					// {
						// self.AnimTrackComponent().Flags() &= ~ANF_NOINTERRUPT;
						// self.AnimTrackComponent().Flags() |= ANF_NOACCUMULATION;
						// DebugLog("pFlags: " + LocalPlayer.Actor().PlayerFlags());
						// break;
					// }
				// }
				
				lastButtons = buttons;
				buttons = self.Owner().Buttons();
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnSpawn()
			{
				int netID = BP::Actor::NetID(self.Owner().Actor().CastToActor());
				@BP::Players[netID].weapons[id].script = @this;
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnBeginFire()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnFire()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnEndFire()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnLower()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnRaise()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnHoldster()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			void OnFiredParticleFromAnim(kParticle@ particle)
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			// Called as soon as the weapon is equipped
			//------------------------------------------------------------------------------------------------------------------------
			void OnEquipped()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
			// Called every game tick even if not equipped
			//------------------------------------------------------------------------------------------------------------------------
			void OnGameTick()
			{
				
			}
			//------------------------------------------------------------------------------------------------------------------------
		};
	}
}
